#include <ndn-cxx/util/segment-fetcher.hpp>
#include <ndn-cxx/security/validator-null.hpp>

#include <iostream>

void
onInterest(const ndn::InterestFilter& filter, const ndn::Interest& interest) {
  std::cout << "Got interest for " << interest << std::endl;
}

int main() {
  ndn::Face face;

  /*face.setInterestFilter("/example/testApp",
                         bind(&onInterest, _1, _2),
                         [&face] (const ndn::Name& name, const std::string& msg) {
                           std::cout << "\nRegister failed " << name  << " "
                                     << msg << std::endl;
                         });*/

  ndn::Interest interest("/example/testApp");
  interest.setInterestLifetime(ndn::time::milliseconds(4));

  auto fetcher = ndn::util::SegmentFetcher::start(face, interest, ndn::security::v2::getAcceptAllValidator());

  fetcher->onComplete.connect([] (ndn::ConstBufferPtr bufferPtr) {
                               std::cout << "Got data" <<std::endl;
                             });

  fetcher->onError.connect([] (uint32_t errorCode, const std::string& msg) {
                            std::cout << "error: " << errorCode << " msg: " << msg <<std::endl;
                          });

  face.processEvents();

  return 0;
}
